2002-07-18  Harri Porten  <porten@kde.org>

	* kspread_cell.h: store the obscuring lest list in a QValueList
	as QPtrList has a rather high memory overhead offset (for empty lists).
	Saves ~20 bytes per cell. More optimizations should be possible by
	converting the two others lists and using a special KSpreadCellList
	class.

2002-07-16  Harri Porten  <porten@kde.org>

	* kspread_dlg_layout.cc: warning free layouts, switched to using
	enums for flags rather than hardcoded values
	* kspread_cell.h: commented out m_bShrinkToSize. Any wants to put
	it to use ?

2002-04-05 Philipp Müller <philipp.mueller@gmx.de>
	* fixed bug with dynamic headers/footers "<table> <page>" in localized version
	* fixed bug with copy&paste of formulas (DEC2HEX))

2002-01-11 Joseph Wenninger <jowenn@kde.org>
	* added DCOP access to maxRow() and maxColumn() of the table  and to isDefault() of the cell

2002-01-10 Lukas Tinkl <lukas@kde.org>
	* implemented 19 new statistical functions (BETADIST, GAMMADIST, POISSON, etc.)

2001-11-25  David Faure  <faure@kde.org>

	* Implemented visual feedback during search & search-replace
	* Search cells using layout order (topleft to bottomright) instead of internal order
	* Allow to search in numerical fields, this shouldn't be disallowed
	* Implemented "from cursor" option
	* Correctly abort if aborting a replacement

2001-10-10  David Faure  <faure@kde.org>

	* Replaced m_bValue, m_bBool, m_bDate, m_bTime, m_bText by a simple enum m_dataType
	  (note that sizeof(KSpreadCell) is still 356! [was 364])
	* The datatype is saved into the XML file, to make loading faster and safer
	* checkValue() is now checkTextInput(), made modular, and not used when loading
	(except for old documents, lacking the datatype)
	* Fixed applying text format
	* Fixed incPrecision (really stupid bug)
	* Saving uses KSpreadLayout::save again. Passes a "bool force" around for copy/paste.
	* Some renamings (formatNumer->formatType, faktor->factor, formular->formula...)
	* isValue() is now isNumeric() for consistency
	* Smaller file when saving (no empty <format> and <cell> tags)
	* Save numbers in a locale-independent way. Didn't manage to find a way to do that
	or bools (while still restoring the cell value to its original text....)
	* setErrorMessage() calls for errors while loading
	* fixed setEnabled in CellLayoutDlg so that I can change precision on a whole row/column
	* added debug hotkey (Ctrl+Shift+V, as in KWord)
	* reversed CHANGES entries and put them into Changelog, so that one can finally
	use XEmacs' ChangeLog facility (C-x 4 a)

2001-04-27-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can copy just text, so you can paste to other application.

2001-04-02-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now spellChecking can spell an area.

2001-03-27-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Apply patch from Alexander Bürger <acfb@stw-bonn.de>
Now when you copy/paste and you select an area you fill
all the area.
Thanks a lot.

2001-03-21-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now there is a menu when you click on statusbar to select
the calc which made when you select an area

2001-03-14-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now when you resize a col/row until 0 you hide row/col

2001-02-21-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add new mathematic function : ROMAN

2001-02-15-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can paste a text plain ( you can copy a text between for example
a text which is in kwrite and kspread)

2001-02-09-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now you can configure spell checking in local.
You don't change global "spell checking" config.

2001-02-07-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can create a hyperlink with internet link or email

2001-02-03-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Add three new functions hours,seconds,minutes
These functions returns hour,second or minutes in a time expression.

2001-01-29-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can used "Area name" in formula
example =sum('kspread')

2001-01-28-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now you can hide/show formula bar (editWidget and posWidget)
Fix layout in kspread_dlg_preference

2001-01-24-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
now you can define "Default page layout parameters" (size and orientation)

2001-01-08-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add new functions : ISDATE ISTIME DECSEX (convert decimal to time value)
SEXDEC( converts time value to decimal)

2001-01-03-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can create "Sort list" for autofill

2001-01-02-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can "don't print a text"
used "cell layout" dialogbox -> misc -> "don't print text"

2000-12-29-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can change default grid color
-Undo works when you change type of cell (combobox, button, normal)
-Add "Selection List"

2000-12-27-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can see what you print with "Preview"
I used ghostview.

2000-12-18-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can define what you want to write in statusbar when you select
an area:
	sum
	average
	count
	min
	max
you can configure it in "Configure dialogBox" -> misc

2000-12-11-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can hide/show col/row header

2000-12-08-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can configure the number of page when you begin kspread (when you don't specify
a file name)

2000-12-05-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can hide/show column/row

2000-12-03-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now you can validate on integer
Now you can validate on text length ( when value is a string)
Add RANDBETWEEN function

2000-12-02-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Add new functions IMCOS, IMSIN, IMPOWER, IMSQRT, IMEXP, IMLN
Add new functions ISEVEN, ISODD, ODD, EVEN, DELTA

2000-11-28-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Add new math functions IMDIV, SUMPRODUCT  , SUMX2PY2 ,    SUMX2MY2    ,  SUM2XMY

2000-11-22-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now kspread understands complex number
you can add /sub complex number
COMPLEX, IMREAL, IMAGINARY, IMSUB, IMSUM

2000-11-21-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now you can copy and insert in same time (For the moment just for column/row)

2000-11-20-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can insert/remove multiple cells

2000-11-16-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can insert/remove multiple column/row ( select area )

2000-11-11-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now kspread_dlg_layout works when you select an entire column/row(s)

2000-11-09-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Fix bug when we copy/paste cell and row/column has layout parameters
-Bug fix

2000-11-08-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add new functions : OCT2BIN ,OCT2HEX,OCT2DEC ; HEX2BIN ,HEX2OCT,HEX2DEC ; BIN2HEX ,BIN2OCT,BIN2DEC
renamed DECBIN -> DEC2BIN  , DECHEx -> DEC2HEX , DECOCT -> DEC2OCT but there is against
compatibility with old function you can used against DECHEX, DECOCT, DECBIN

2000-11-07-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can hide zero value, it's an option (kspread_dlg_preference -> hide zero)
-Now you can convert first letter in upper case (kspread_dlg_preference-> "convert ...")
-You can used special paste on a column/row

2000-11-03-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Now you can apply parameters at a entire column/row

2000-11-01-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
Add some financial functions, patch given by  Jonathan Singer <jsinger@genome.wi.mit.edu>
thanks

2000-10-27-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add Validity function

2000-10-25-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Now you can see text when text is align to right or middle, and show a red triangle
when text is too large and you align to right or left.

2000-10-24-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add indent functions used when text is aligned to left

2000-10-23-Montel laurent <lmontel@mandrakesoft.com>
----------------------------------------------------
-Add new time format ( 10:05:5 AM, 10:05 AM, 10 h 05 min 5 s )
-Some fix.

Summary 2000-09-19 -> 2000-09-25
*Torben implemented removechild (Now you can remove a chart in
kspread for example)
Torben rewrote kspread_dlg_formula
thanks a lot

*laurent
some fixes

Summary 2000-09-19 -> 2000-09-23
*David : bug fix
non latin1 bug
Improved automatic check format (When number is >1E+10 format is changed in
scientific format)
Update DTD file

thanks

*Laurent:
some bugs fixes

2000-09-19-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Fixed changing page orientation
* Fixed default precision for percentages when autodetected

2000-09-18-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Improved Undo for "delete". Now works when you delete a column or row

2000-09-17-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Implemented Undo for "Paste"
* Bugs fixes

Summary 2000-09-05 -> 2000-09-16
Montel laurent <montell@club-internet.fr>
-----------------------------------------
* Implemented Undo for "Conditional cell Attribut"
* Implemented Undo for "Show Table" "Hide Table"
* Implemented Undo For "insert/remove cell"
* Undo layout works when you selected an entire row/column
* bugs fixes :
-close editor when you switch/insert/remove table
-others bugs (I don't remember )

2000-09-05-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Implemented Undo for autofill

Summary 2000-08-30 -> 2000-09-03
Montel laurent <montell@club-internet.fr>
-----------------------------------------
-Fix some bugs with cell merged when you used kspread_dlg_format
-Now "special paste" -> "without border" works again
-other some bugs

Summary 2000-08-27 -> 2000-08-30
Montel laurent <montell@club-internet.fr>
-----------------------------------------
* Now when you select an area (with mouse) you select all cell merged
* Now I reduce the numbre of refreshing of cell merged
* Now when you accross a merged cell it works
* fix others small fixes

2000-08-27-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Fix bug when you changed table in "Split view" mode
-when you used kspread_dlg_formula
-when you used kspread_dlg_reference
*Fix bug when you moved on hyperlink

2000-08-25-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Fix bug when you used "Split view"
-"Remove table" works
-"change table" works

Summary 2000-08-22 -> 2000-08-25
Montel laurent <montell@club-internet.fr>
-----------------------------------------
* Implemented Undo When you used "Check Spelling"
* Fix bug when you used "Split View" :
-"Preference" works
-"Show table" works
-"Hide table" works

Summary 2000-08-19 -> 2000-08-22
Montel laurent <montell@club-internet.fr>
-----------------------------------------
* Implemented Undo For "Find and Replace"
* Implemented Undo For "Insert->series"
* Bug fix in kspread_dlg_series
* Undo works when I clear and used "find and replace" on entire row/col
* Undo works again when I changed table name

2000-08-19-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Implemented Undo for merging cells
* Fixed repainting problem when unmerging
* Fixed undo on clear cell

2000-08-18-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Appearance fix when clicking a single cell: doesn't
  look like a selection in the row/column headers anymore.
* Allow to change the number format for an empty cell.
* Pressing Enter in the edit widget without changing the
  value doesn't clear the cell anymore.

2000-08-18-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Implemented Undo/Redo on column/row resizing
* Implemented Undo/Redo on clear cell
* Another fix for merged cells (conditionnal formatting).

2000-08-14-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
* Redraw problem when selecting cells with a border
* F2 switches from cell to edit-widget
* Layout fixes
* Fixes for undo/redo
* Fixes for copy and paste of cells with extra width

2000-08-13-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
Bug fix :
selected an area and press Enter, so you moved
into this area
=>now it reworks

2000-08-11-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
Bug Fix :
Now when you dissociate cells, extrawidth=0
extraheight=0.

2000-08-06-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-fixed :Bug#7608
-Improved kspread_dlg_formula now when there is a text into cell
before to call kspread_dlg_formula, kspread used this text
and add '=' at the beginning and "+" at the end
=>you can completed a formula into kspread_dlg_formula.
For example in cell A1 : =cos(12)
=>call kspread_dlg_formula => =cos(12)+
cell A1 : 10
=>call : =10+

2000-08-04-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Fix a big bug in dependence cell for example =A1+C1
Now it works correctly.

2000-08-02-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now when you insert/remove column/row/cell and there is a chart you refresh it.

2000-07-31-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now Negative and Positive format works with fraction format and others

2000-07-29-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Move "Comment" code to kspread_layout
=>undo works with "comment"
-bug fix
-Bug fix : now ajust area works when a text size is bigger than
cell size. =>( ** )

2000-07-28-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now format works
-You can put different date format.

2000-07-27-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Move m_rotateAngle code and  FormatNumber code to kspread_layout.cc
=>now undo works for formatnumber and rotate.

2000-07-26-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Bug fix : now adjust area reworks when you change size font
or set "vertical text" or change angle etc...
Text size and position are refreshing
-Bug fix : now text color works when you used "conditional cell
attributes" and when you make "negative format" (text color
is red)

2000-07-24-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now when a formula is a time or date, change format to time or date
-Now kspread doesn't recognize money format into formula
because in France for example when you write : =F6, kspread
believes that is 6.00 F
=>it's not a good idea.
It's the same think for DM

2000-07-22-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-bug fix when I copy/paste cells (setPrecision)

2000-07-20-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now vertical text and multirow works when cell merged

2000-07-16-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Add new script functions setTextBold(),setTextUnderLine() etc...

Summary 2000-07-16 ->2000-07-20
Torben corrected bug in save/load embedded component
=>now you can load a kspread file with kchart file
-corrected print bug.

2000-07-15-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now kspread can recognize scientific format when you write
1.25E-5
-Imporved kspread_dlg_layout
=>now I move backgroundcolor to pattern page
so now you can see pattern with its backgroundcolor
-Imporved show example format, I think that it works.
-Add new functions : DECHEX convert a decimal number to hexadecimal
DECBIN, DECOCT
-Add new fraction format (One digit, two digits and three digits)
Algo gave by jp martin
-Add functions documentations.

Torben changes:
-Rewritten drawing code.
It's very nice.
Correct some bugs, etc...

2000-07-12-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Add new script functions :
setMultirow(bool), multiRow(), setVerticalText(bool), verticalText()
setPrefix(),prefix(),setPostfix(),postfix(),setAlign(),align()
setAlignY(),align(),getFormatNumber(),  setFormatNumber()
-Improved a little kspread_dlg_layout->Font

Summary 2000-07-12 ->2000-07-15
Torben improved against kspread =>fix a lot of bugs
WorkED with David Faure on kofficelib, etc...

2000-07-09-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now you write 11:5am, 11:5 am, 11:5:5 am 11:5:5am
kspread test all this string and recognize a time format.
-Now there is completion mode. For the moment completion mode is automatic.

Summary 2000-07-09 ->2000-07-12
Torben is come back!
Torben add time and date support in kscript
=>you can write : in cell A1 : 2000-2-2
cell B1 : =A1+2
        =>result : 2000-2-4
Improved undo
bug fix

2000-07-08-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Add new format : time format
there is a bug into klocale, you can't write : 12:15 am
you must write 12:15:08 am (save in international format)
-Bug fix into merge cell
-Now kspread check format into formular.

2000-07-07-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now you can Merge cell and Dissociate cell (when they merged)
but there are against a lot of bug.
-bug fix
-Add new script function (setComment(QString))

2000-07-05-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-bug fix
-Improved kspread_dlg_angle
-Now when you press middle button you can paste fix bug #5009

2000-07-05 Wilco Greven <j.w.greven@student.utwente.nl>
-------------------------------------------------------
- For the sake of consistency, better use Shift instead of Control to extend
  a selection.

2000-07-04-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now kspread can understand Table1!C1 and Table1!c1
it works.
-Improved kspread_dlg_formula

2000-07-01-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Add new format : Fraction format (1/2,1/4,1/8,1/16,1/10,1/100)
-Now you can move into an area when you press enter key, you move
top to bottom and left to right.

2000-06-30-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now kspread support Date
Date is saving in "international format", date can read in each language.

2000-06-14 David Faure <faure@kde.org>
-----------------------------------------------------
Fixed tabbar colors (active table is not 'selected' -> using base())
Speed up KSpreadTextEditor::checkChoose(), might fix i18n problem as well

2000-06-28-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Add new format :scientific format
Becareful, now format doesn't used prefix and postfix.
All format is creating into text : example for money :
12.5 => $ 12.5 but doesn't used prefix and postfix, so now currency symbol
is at the good place.
It's the same think for percent.

For the moment Date format doesn't work (sorry david).

2000-06-25-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now you can select with the mouse an area from bottom to top, from top
to bottom, from right to left and from left to right. Now it works.

2000-06-24-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Apply patch of Robert Wall <rwall@esatclear.ie> thanks a lot
Now you can goto cell or range directly.
KSpreadLocationEditWidget displays cell pos or range, and allows to
enter cell pos or range.
-Now you can write a table name with a space example "Table 1"
-Now you use press Key_Home you go to beginning of the row
and not at cell A1

2000-06-23-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Now you can rotate text into cell
-Remove some duplicate functions or code (column_label->util_column_label
etc...)

2000-06-20-Montel laurent <montell@club-internet.fr>
----------------------------------------------------
-Remove a duplicate function (funct() and insertFunction())
same think

2000-06-19-Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now multirow work when you choose "Middle","Bottom"
-Add new icon lo16-action-series.png created by j.martin
<jpmartin@iroise.com> thanks
-Now commentLabel works but I can't reload comment
bug in qdom (qdom removes '\n')

2000-06-19-Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Rewrite multirow function, now it works
-Now you can show comment when you move mouse on red triangle
there is a bug in new qdom because when I try to load a comment
qdom remove all '\n'
=>showComment doesn't work and blocks kspread

2000-06-14 -David Faure <faure@kde.org>
-----------------------------------------------------
- Fixed what I broke in changeNameCellRef, by completely rewriting it :
  Now Unicode safe ; uses KSpreadPoint to do most of the parsing.
  Also allows spaces in table names - for when KScript supports it too.
  Merged changeNameCellRef and changeNameCellRef2 (added arg 'fullRowOrColumn')
  This fixes inserting/removing rows/columns/cells.

2000-06-11 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Changed some dlg->show() by if(dlg->exec())
because when you press on "cancel", it's not necessary to recalc all
or refresh cell.
-Used new icon loxx-action-delete_table.png
-Insert code of patch created by ...
Now you can go to a selection with kspread_dlg_goto for
example A5:B5

2000-06-11 -David Faure <faure@kde.org>
-----------------------------------------------------
- Cleaned up code for resizing row/column (created paintSizeIndicator to avoid
code duplication and got rid of yellow background :))
- Many fixes in KSpreadDlgLayout (removed hardcoded colorgroups, etc.)
- Made KSpreadLayout return a proper color in textColor() and bgColor()
even if default.

2000-06-10 -David Faure <faure@kde.org>
-----------------------------------------------------
- Many fixes related to colours (obey color schemes; removed many hardcoded colors)
- Removed canvas argument to KSpreadCell::paintCell, since always 0L and since
zooming has to be implemented properly (see koffice@kde.org).

2000-06-05 -David Faure <faure@kde.org>
-----------------------------------------------------
-Fixes for non-latin1 users. grep ascii *cc *h returns nothing anymore,
and grep latin1 only very few safe ones. Please let it remain this way :)
This fix will be tested by Tinkl Lukás.
TODO: trying to make this compile with the no-ascii-casts flags ;-)

2000-06-04 -David Faure <faure@kde.org>
-----------------------------------------------------
-Rewrote sorting algorithm. Much faster ('MinMax' instead of ugly BubbleSort)
-Implemented operators < and > for cells, to give real sorting :
Numbers are sorted as numbers, and are always smaller than texts (as Excel does)
-Re-enabled empty cells in sorting, creating nonDefaultCells when necessary.
-Got rid of "onlyRow" and "onlyColumn" hacks
-Fixed the sort dialog for those cases

2000-06-02 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-improved layout managment in kspread_dlg_layout->pattern
-Now "Find and replace" works. I add two options :
"case sensitive"
"Find Whole Words only"

2000-06-01 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Improved layout managment in kspread_dlg_layout->border
-Now you can customize penstyle ,you can change size
and style of penStyle

2000-05-31 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Change some icon name because the people who improved and
moved icons in kdelibs or toolbar/hicolor etc... changed name
(for exemple bold -> text_bold)

2000-05-30 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now in "special paste" you can put just comment
-Add new icon "special paste" made by jp.martin <jpmartin@iroise.com> thanks

2000-05-27 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Bug fix in comment
-Add new icons (lo22-action-inserttable,lo22-action-cell_edit,
lo22-action-deletecell) made by jp.martin <jpmartin@iroise.com> thanks
(improved other icons)

2000-05-24 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Correct bug when I reload comment, correction gived by simon Hausmann
thanks a lot

2000-05-23 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can put a comment into a cell
Be careful there are against a bug : when I try to reload comment
"\n" were replacing by space => anybody has an idea ?
icons (lo22-action-comment ,lo22-action-removecomment, lo22-insertcell,
lo22-action-remove cell) created by jp.martin <jpmartin@iroise.com> thanks

2000-05-21 -David Faure <faure@kde.org>
---------------------------------------
-Small speedup in KSpreadTable::recalc.
-Major speedup in changeNameCellRef, which changes texts but doesn't update
dependencies - no need for that since we recalc the tables first.
In my big document, it took _forever_ when inserting a row.
-KSpreadCell::setText is now KSpreadCell::setCellText to help grepping :),
and added bool updateDepends for the above

-Removed duplicate call to map->update in load, since completeLoading does it
-Fixed kspreadfunc_app by adding KSpreadFactory::dcopObject
-Removed some unused stuff (sig_updateCell etc.)
-KSpreadTable::emit_updateCell() is now KSpreadTable::updateCell() (doesn't emit)
-Some other renamings to help finding things (e.g. popup-menu slots).
-New kdebug area: 36002, for the cell dependency stuff, very verbose output.
Laurent, use kdebugdialog to turn it off so that it won't annoy you :)
-Added some missing m_pDoc->setModified( true ) (for insert/remove row/column)

-I get some strange "QPainter: Internal error; no available GC" when inserting a row...
They come from the regionInvalidated stuff and I got 507 levels of recursive calls in
the backtrace :(

-Added Format/Default (everything in the popupmenu should be in the menus too...)
-Fixed that default to precision = -1
-Fixed stupid bug in incPrecision (I think I'm responsible for that one :)

2000-05-20 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can put a vertical text  example : a
                                            b
                                            c
                                            g
This is an optional function.
=>you can show this function if you used kedittoolbar and add "Vertical text"
As kedittoolbar doesn't work for this moment, add this line to your
personal kspread.rc file
<Action name="verticaltext"/>

(Note from David: if it didn't appear, delete the local kspread.rc file...)

2000-05-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Improved layout management in kspread_dlg_layout->font.

2000-05-16 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can strike out the text

2000-05-14 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-bug fix
-add icons improved by jp.martin <jpmartin@iroise.com> thanks
bold,italic,multirow,underline etc... thanks a lot.

2000-05-12 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now I created a new dialog box "Preference"
move "show grid","show formular","LC mode","Column number" into
this dialog box
-Bug fix

2000-05-11 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now when you resize row or column you can show its size.
-Add new help formula in kspread_dlg_formula.

2000-05-08 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can show column number
=>replace A B C ... by 1 2 3 ...
-Add function equalize row and equalize column
=>used width ou height max

2000-05-07 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add two functions upper,lower and increase size font,decrease size font
but it's optional icon.
You can add them with kedittoolbar
lo22-action-upper.png lo22-action-fontsizedown.png lo22-action-fontsizeup.png
lo22-action-lower.png lo22-action-resizecol.png lo22-action-resizerow.png
icons created by jp.martin <jpmartin@iroise.com> thanks
bug fix
Replace all QMessageBox by KMessageBox

2000-05-06 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can show area selected example A1:B5
(idea given by jp.martin <jpmartin@iroise.com> thanks )
-Now there is LC mode => you can show area selected
as 3Lx5C, L1C1 (A1)
-bug fix
-Now you can resize differents row or column
icon lo22-action-adjustrow.png lo22-action-adjustcol.png
lo22-action-middle.png,lo22-action-top.png,lo22-action-bottom.png
created by jp.martin <jpmartin@iroise.com> thanks
-Improved kspread_dlg_resize
-start to replace QMessageBox by KMessageBox

2000-05-05 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can select "Top" "Middle" "Bottom" position of text in menubar
(idea given by jp.martin <jpmartin@iroise.com> thanks )
-Bug fix in kspread_dlg_layout bug reported by jp.martin <jpmartin@iroise.com>
thanks

2000-05-04 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Change cursor when you want to resize column or row
I used now good cursor for each type (column or row)
Bug report by jp.martin <jpmartin@iroise.com> thanks
-bug fix

2000-05-03 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can give height and width of cells in kspread_dlg_layout
-Add new function INV => multiply by -1 each value
-bug fix

2000-05-01 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add modal for all MessageBox (bug reported by jp.martin <jpmartin@iroise.com>)
-Now when you change boder color in toolbar all borders into area selected
changed (idea of jp.martin <jpmartin@iroise.com>)
=>thanks to jp.martin
-Now undoLayout works
-Bug Fix

2000-04-30 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now remove AreaName when table target is removed
-Now "Show page Border" is saved
-Now init toggle button in initialPosition() because used QTimer::singleShot
=> all is init before change state of button.
-Add caption to kspread_dlg_format
-Add modal for all dialogbox (bug reported by jp.martin <jpmartin@iroise.com>)

2000-04-29 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add two functions : sign which return -1 if number is negative, 1 if positive
and zero when it's null
and atan2
-Start to create help for kspread_dlg_formula
-Improved kspread_dlg_conditionnal

2000-04-21 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add caption in kspread_dlg_layout, kspread_dlg_oszi

2000-04-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new mode : formular mode => now you can see formular in cell

2000-04-16 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Use kformula icon because they are more nice

2000-04-10 -David Faure <faure@kde.org>
---------------------------------------
-Improve error handling : don't abort if a cell is invalid
Still don't know why I get a row = -1 for a cell, but at least it loads.

2000-04-13 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can remove an area name.

2000-04-12 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can put a name to an area.

2000-04-10 -David Faure <faure@kde.org>
---------------------------------------
-Save and restore active table and cell

2000-04-09 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add Improved "insert formula"

2000-04-01 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add geometrical series

-Now Torben is back. So I corrected bug in kscript. Now Int value
can be transforme in Double Value => Create_formula works fine.
-He works on bugs thanks.

-David Faure works too on bugs, thanks.
So I think that kspread should be the best spread on linux :).

2000-03-24 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Bug fix
-Now check spelling works => correct kspell.cpp
replace void slotModalDone( const char * ) by void slotModalDone( const QString & )

2000-03-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add financial functions that Jonathan Singer created.

2000-03-04 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Improved ReadWrite => when you load in konqueror a kspread file
you can't resize column or row, you can't rename table etc...

2000-03-03 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new dialog box "Linear Series" =>now you can create linear series
-Improved kspread_dlg_conditional =>now there is a preview
But I can't change color because there isn't "setColor" for a QLineEdit
bug ? perhaps in QT2.2
Now I use knumvalidator for QLineEdit
-Bug fix . Fix bug that Michael Koch reported me in kspread_dlg_formula
  centered border on cell grid ..
-Bug fix in KSpread_dlg_conditional.

2000-02-26 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new function "find"
-bug fix

2000-02-24 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new functions upper and lower
-Now "hide table" and "hide grid" are saving
-Improved "kspread_dlg_show"
-Add shortcut

2000-02-21 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new functions : NAND,NOR
-Now you can "Underline"

2000-02-20 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new fonctions : AND, OR, MOD, BINO, INVBINO

2000-02-19 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can show or hide grid
-Fix bug report by Michael Koch (use KNumInput when you resize column or row)
-Bug fix

2000-02-18 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now Relational cell attribut is saving in file

2000-02-11 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Improved : Relational cell attribut
Now parameter are setting when you open conditional dialog.
Reduce memory to store condition.

2000-02-06 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new Function : conditional
-When you want to define a value for example you want to see all cells which
are a value equal to 5 you can attribut a color and a font.

=>there are three conditions.
There is against a lot of work (save condition, reduce memory to store condition,
and put the old condition when you active dialog.
=> I try to do this thinks this week if I have time


2000-01-07 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Bug fix : When you copy a value in a cell all is recalcing
(bug that David Faure found.)

Summary 2000-01-07 ->2000-02-06
Shaumann Port KSpread and all koffice to new kpart

1999-12-30 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add i18n where I forgot to install it
-Now you can validate MultiRow in "Cell Layout"

1999-12-29 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Bug fix in special paste (right border and bottom border are not
installing in new cell when you choose Text or NoBorder parameter)
-Clean up in code
-Add setFocus in different dialog box

1999-12-28 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can put a pattern in a cell
-bug fix in choose border
-Now you can choose border directly with the mouse in the area.

1999-12-27 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Improved choose border (look at in "Cell Layout")

1999-12-23 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can make diagonal in a cell.

1999-12-22 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Replace   QPushButton by   KColorButton
because when you insert a style (a theme) in kde you can't change color
in a QPushButton (use color of theme).

-Add new style of line   DashDotLine and  DashDotDotLine

1999-12-16 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can put text to bottom ,middle or top in a cell

Summary 1999-12-03 ->1999-12-16
1999-12-15 KRASH release.

1999-12-03 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add functions PERMUT COMBIN and fract

Summary 1999-11-28 ->1999-12-03
A bug was fixed by Mr Well (I believe)
=>Now kspread don't crash when you write bad tablename in a cell
thanks.

1999-11-28 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add functions time and date

Summary 1999-11-20 ->1999-11-28
Torben weis had installed possibity to execute directly script
in kspread => Scripts -> scripts -> callme or widget_kspread (with
qt-widget)

Add possibity to create extern function ex :
	-percent(2,5)
it's not a function in kspread
it's loading a the begining =>math.ks
Add a Manual for kscript in koffice/lib/kscript/Manual
=>Now everybody can create extern function or script

1999-11-20 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can select a area when you click and press CTRL
-Now "Show page border" works
	=> togglePageBorders was bad written in connect function

-for testing oszilloscope :
Write in Table : For example put values between 1 and 5 in the cell C1.
and in cell C5 : "=sin(C1)"

In oszilloscope :
Cell X : Table1!C1
From : 1
to :2
ResultX : Table!C5
=>CALC

you can write in table in cell C6 "=cos(C1)"
In oszilloscope ResultY: Table1!C6
Then putting C6 in resultY gives you a circle plot on the ozsilloscope.
=>CALC

you can move cursors =>measure
It's a very good function.


1999-11-18 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add pow function

Summary 1999-11-12 ->1999-11-18
Torben weis had installed : oszilloscope
and fixes a lot of bug.

1999-11-12 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new functions for script
	-bgColor()
	-setBgColor(int,int,int)
	-setBgColor(QString)
	-textColor()
	-setTextColor(int,int,int)
	-setTextColor(QString)  (ex: setTextColor("#39fd59"))
see result in  example15.ks
-Bug fix : when you insert a cell in bottom or right
now text offset is recalcing.

1999-11-11 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-bugfix Now changeref works
-Now you can put and remove percent in a cell.
-Now you can put and remove format money in a cell


Summary 1999-11-02 ->1999-11-11

Torben weis has installed a new dialogbox for choose a table format
	=>2 styles of table.

1999-11-02 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-change name in kspread_dlg_formula to correspond with kspread_interpreter
(for example NO =>not etc ...)
Now it works

Summary 1999-10-17 ->1999-10-30

Torben weis has installed posibility to make script in kspread.
You can test it :
	- execute kspread &
	- kscript example15.ks

We can write in a specific table, create new table change name ...

1999-10-30 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Refresh icon text color and icon background color

1999-10-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-bug fix gotoLocation now when you createanchor for going to other
cell, now it works.
-Now you can ajust one cell

1999-10-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------

Torben weis ported kspread to new code (shared libs) and made a good work
on kspread bugs fix (a lot) and Improved kspread (thanks).

Summary 1999-09-23 ->1999-10-17
-Now you can clear area
-You can ajust area
-Now when you insert or remove column (or row) all is recalcing.
-Fix bug When you insert and remove column and row (Now it works)
-When you change name of a table, now all cells which refere to this table
now text is change to refere to new name.
-Now when you insert column (row) or remove column (row) and there are cell
which refere others cells so if these cells are moving so I modifie
reference.
-Now Insert and remove column ( or row) works
	=>change specific reference according to name table
	and change in differents tables.
-Fix bug : Now when you delete a formula it works
-Now you can create border directly
-Now you can insert and remove cell (=>move cell at right or bottom etc..)
-Refresh dependence when you insert and remove cell
-Improved Special paste now you can paste only value.
-Now you can hide different tables and it's saving.

1999-09-23 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now you can create a area when you click and press CTRL
-Add new dialog box for resize column or row

1999-09-22 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Bug fix : Now when you insert or remove column or row,there is recalculing
-Add new button on formula toolbar (SUM and Product)
-bugfix
-Now you can copy a function with

1999-09-21 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now Special paste =>operation ,works
-Reggie had a good idea to add a Toolbar for formula, So I had it
and now when you create formula with kformula widget a toolbar appear.
-Now when you doubleclick on cell you create a new cell with old text
inside so you can add text in this cell.

1999-09-20 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add now function REPT
-When you selection a text in editWidget and first character egal to !
and you click on bold or italic you add <b> </b> or <i> </i>
-Start improved of special paste => operation add ,mult etc...

1999-09-18 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
Now when you click on bold button or italic button and in the cell
it's a richtext so you add <i> </i> or <b> </b> .
So text is in italic or bold.

1999-09-17 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Cleanup in kspread_dlg_create
-Improved Kspread_dlg_create. Now if you choose a function in a cell
and you unselect it, when you close kspread_dlg_create, cell is recreating.
-Add new button for choose function, you can add function if = is not here
in the cell or editwidget = is add.

1999-09-16 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Now Kspread_dlg_create works ,you can select with mouse.
-MouseDoubleClick on canvas call layout_dlg.


1999-09-15 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
-Add new dialogBox kspread_dlg_anchor now you can create Anchor
-Add currencySymbol so now when you click on Money button it adds
symbol of your land but I test it on american language so I don't know
if it works on others languages.
-Add new dialogue box Now when you choose your function there is
this dialogBox which arrived and show you what do you write.
It give the number of parameters etc ...

1999-09-13 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
Add new functions :
	-logic : IF, NO, TRUE, FALSE
	-Math : INT
	-Text : EXACT, RIGHT, LEFT, JOIN ,LEN, STXT

1999-09-10 -Montel laurent <montell@club-internet.fr>
-----------------------------------------------------
Now you can use Key_home : go to cell "A1"
	Key_Prior =>Key_PageUp : Decrease of 10 cells => go to cell "x(n-10)"
	Key_Next =>Key_PageDown: Increase of 10 cells => go to cell "x(n+10)"
Add new function in Kspread_dlg_sort Now you can sort in mode Decrease or
Increase.
bugs fix
Add CTRL+Key_G => call dlg : goto

1999-09-05 - Montel laurent <montell@club-internet.fr>
------------------------------------------------------
Improved Special paste now you can paste with link between different tables
(Now link : Table2!A7 if you change table)
Now copy all border (right and bottom)

1999-08-31 - Montel laurent <montell@club-internet.fr>
------------------------------------------------------
Now when you write "=" in cell and you click on the table
you create link between cells.

1999-03-01  David Faure  <faure@kde.org>

	* kspread_view.cc (runLocalScript):
	New menu item : 'run local scripts'.
	Usage : 'edit local scripts', type the script, then
	'reload scripts' (will save & close the buffer), then 'run local
	scripts'. Will have to find a better User Interface !

6.2.1999 - Reggie:
------------------
- Fixes for drawing cell borders and cell backgrounds in KoPrintExt

22.1.1999 - Reggie:
-------------------
- Fix for glibc2 systems in lex.l
- KoPrintExt is working correctly now (correct rows/cols are displayed and
  background colors are displayed)
- In KoPrintExt no grid is drawn

Sun May 31 03:11:57 1998  Torben Weis  <weis@localhost>

	* kspread_table.cc (insertChart): Support for KChart added

	* kspread_view.h (View_skel): Improved Marker painting

	* kspread_table.cc (saveCellRect): Added cut/copy/paste

Sun May 24 13:22:11 1998  Torben Weis  <weis@localhost>

	* kspread_view.cc (slotScrollHorz): Fixed ugly marker
	  drawing bug during scrolling.

Mon May  4 13:06:49 1998  Torben Weis  <weis@localhost>

	* kspread_doc.cc (slotChangePaperLayout): Moved Page Layout Dialog
	  to KSpreadDoc

	* (paperLayoutDlg): Use Reggies cool KoPageLayoutDia dialog

Sat May  2 16:17:59 1998  Torben Weis  <weis@localhost>

	* kspread_doc.cc (save): Enable saving & loading

Thu Apr 30 02:00:53 1998  Torben Weis  <weis@localhost>

	* kspread_main.cc (start): Changed to work with new
	                  koffice libs.

Wed Apr 22 01:45:47 1998  Torben Weis  <weis@localhost>

	* (resizeEvent): Embedded tables do no longer display
	  scrollbars and additional widgets. They are only shown

	* kspread_view.cc (KSpreadChildFrame): One can now
	  embed child objects in the table.

Tue Apr 21 00:17:41 1998  Torben Weis  <weis@localhost>

	* kspread_view.cc (enableRedo): Undo/Redo works now

	* kspread_dlg_scripts.cc (updateList): Fixed path for
	  global scripts.

	* (slotRename): Bug fixes.

	* kspread_table.cc (deleteColumn): Deleting rows and
	  columns does work now.

	* kspread_view.cc (insertRow): Inserting rows and columns
	  works now.

	* (addTable): Can handle multiple tables.

Mon Apr 20 02:10:29 1998  Torben Weis  <weis@localhost>

	* kspread.idl: Selecting font and font sizes work now.

Sun Apr 19 18:03:26 1998  Torben Weis  <weis@localhost>

	* kspread_view.cc (slotUpdateView): View does now connect to the
	  documemts signals. If the document changes, every view is
	  updated. Does not work in every situation right now.

	* kspread_view.h (View_skel): Supports multiple views now

